option casemap:none
OPTION FRAME:noauto

.nolist
.nocref

IDD_DLG1 equ 1000
WM_CLOSE equ 0010h

extrn MessageBoxA : proc
extrn GetModuleHandleA : proc
extrn EndDialog: proc
extrn DialogBoxParamA: proc

DialogBoxParam equ <DialogBoxParamA>
GetModuleHandle equ <GetModuleHandleA>
MessageBox equ <MessageBoxA>

includelib USER32.DLL
includelib KERNEL32.DLL


.data
align 01
szClass			db  'Win64class', 0
szAppName		db	'First Window', 0
szError			db  "Can't run in the windows version",0
szCaption		db	'Error', 0
szOkUntilNow	db	"Ok until now",0
szOk			db  "Ok",0

.data?
align 08
hInstance	QWORD ?
lpCmdLine	QWORD ?

.code
start:
	
	sub rsp, 38h
	mov r9, 0
	lea r8, [szClass]
	lea rdx,[szAppName]
	xor rcx, rcx
	call MessageBoxA
	mov QWORD [rsp + 20h], 0
	lea r9, [DlgProc]
	xor r8, r8
	mov rdx, IDD_DLG1
	mov rcx, qword [hInstance]
	call DialogBoxParam
	add rsp, 38h
	ret
	
	DlgProc proc hDlg:QWORD, uMsg:QWORD, wParam:QWORD, lParam:QWORD

	mov qword [hDlg], rcx
	mov qword [uMsg], rdx
	mov qword [wParam], r8
	mov qword [lParam], r9

	
		.if rdx == WM_CLOSE
			sub rsp, 28h
			mov rdx, 0
			mov rcx, qword [hDlg]
			call EndDialog
			add rsp, 28h
		.else
			xor rax, rax
			ret
		.endif
		
		xor rax, rax
		inc rax
		ret

	DlgProc endp

end start
